package jp.ac.do_johodai.j314.sw.je;

import com.hp.hpl.jena.graph.*;
import com.hp.hpl.jena.reasoner.rulesys.builtins.BaseBuiltin;
import com.hp.hpl.jena.reasoner.rulesys.RuleContext;

/**
 * a3newビルトインで作成したAcerola3Dのフレームを
 * 実際に表示させたり、隠したりするためのビルトイン。
 * ビルトインの名前は'a3setVisible'。
 * 第1引数がAcerola3Dを特定するためのリソース。
 * 第2引数が1なら表示、0なら非表示にする。
 */
public class A3SetVisibleBuiltin extends BaseBuiltin {
    public String getName() {
        return "a3setVisible";
    }

    public int getArgLength() {
        return 2;
    }

    public boolean bodyCall(Node[] args, int length, RuleContext context) {
        if (length != 2)
            return false;
        if (!A3NewBuiltin.hash.containsKey(args[0]))
            return false;
        return setVisible(args);
    }

    public void headAction(Node[] args, int length, RuleContext context) {
        setVisible(args);
    }

    boolean setVisible(Node[] args) {
        A3NewBuiltin.MyFrame f = A3NewBuiltin.hash.get(args[0]);
        String v = ((Node_Literal) args[1]).getLiteralLexicalForm();
        v.trim();
        int i = Integer.parseInt(v);
        if (i == 0)
            f.setVisible(false);
        else
            f.setVisible(true);
        return true;
    }
}
